
From: Adam Szalkowski <adamsz@gmx.net>

Fix DiSEqC problems.

Signed-off-by: Adam Szalkowski <adam@szalkowski.de>
Signed-off-by: Johannes Stezenbach <js@linuxtv.org>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/media/dvb/frontends/cx24110.c |   13 ++++++++-----
 1 files changed, 8 insertions(+), 5 deletions(-)

diff -puN drivers/media/dvb/frontends/cx24110.c~dvb-frontend-cx24110-another-diseqc-fix drivers/media/dvb/frontends/cx24110.c
--- devel/drivers/media/dvb/frontends/cx24110.c~dvb-frontend-cx24110-another-diseqc-fix	2005-09-04 16:51:20.000000000 -0700
+++ devel-akpm/drivers/media/dvb/frontends/cx24110.c	2005-09-04 16:51:20.000000000 -0700
@@ -398,7 +398,8 @@ static int cx24110_diseqc_send_burst(str
 		return -EINVAL;
 
 	rv = cx24110_readreg(state, 0x77);
-	cx24110_writereg(state, 0x77, rv | 0x04);
+	if (!(rv & 0x04))
+		cx24110_writereg(state, 0x77, rv | 0x04);
 
 	rv = cx24110_readreg(state, 0x76);
 	cx24110_writereg(state, 0x76, ((rv & 0x90) | 0x40 | bit));
@@ -418,14 +419,16 @@ static int cx24110_send_diseqc_msg(struc
 		cx24110_writereg(state, 0x79 + i, cmd->msg[i]);
 
 	rv = cx24110_readreg(state, 0x77);
-	cx24110_writereg(state, 0x77, rv & ~0x04);
-	msleep(30); /* reportedly fixes switching problems */
+	if (rv & 0x04) {
+		cx24110_writereg(state, 0x77, rv & ~0x04);
+		msleep(30); /* reportedly fixes switching problems */
+	}
 
 	rv = cx24110_readreg(state, 0x76);
 
 	cx24110_writereg(state, 0x76, ((rv & 0x90) | 0x40) | ((cmd->msg_len-3) & 3));
-	for (i=500; i-- > 0 && !(cx24110_readreg(state,0x76)&0x40);)
-		; /* wait for LNB ready */
+	for (i=100; i-- > 0 && !(cx24110_readreg(state,0x76)&0x40);)
+		msleep(1); /* wait for LNB ready */
 
 	return 0;
 }
_
